{{
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Breakout
//
// Author: Michel Lampo
// Updated: 15/12/2012
// Designed For: P8X32A
// Version: 1.0
//
// Copyright (c) 2012 Michel Lampo
// See end of file for terms of use.
//
// Update History:
//
// v0.1 - Alpha release - 15/12/2012.
//
// Run the program with the specified driver hardware.
//         
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}}

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  _pinGroup = 2
  _startUpWait = 5

VAR

  word XPos, YPos, XDir, YDir

OBJ

  tmp        : "VGA64_TMPEngine.spin"
  retronitus : "retronitus"
  boxes[20]  : "BreakoutBox"
  padle      : "BreakoutBox"
  mouse      : "mouse"
  pst        : "Parallax Serial Terminal"

PUB Start | box, _XDir, _YDir, _XPos, _YPos

  XDir := 1
  YDir := 1

  ifnot(tmp.TMPEngineStart(_pinGroup, @XPos, @YPos))
    reboot

  retronitus.start(10, 11)
    
  pst.Start(115_200)
  repeat box from 0 to 19
    boxes[box].Disable

  boxes[0].EnablePos(5, 5, 5)
  boxes[1].EnablePos(3, 25, 5)
  boxes[2].EnablePos(16, 10, 5)  

  'start mouse and set bound parameters
  mouse.start(24, 25)
  mouse.bound_limits(0, 0, 0, 400, 300, 0)
  mouse.bound_scales(1, 1, 0)
  mouse.bound_preset(200, 270, 0)  

  padle.EnablePos(28, 17, 6)

  waitcnt((clkfreq * _startUpWait) + cnt)

'  retronitus.playMusic(@nyan)

  XPos := ((||cnt?) // 640)
  YPos := ((||cnt?) // 480)
  tmp.mouseCursorColor(cnt?)
  tmp.mouseCursorTile(@ballPointer)

  repeat box from 0 to 19
    if boxes[box].IsActive
      tmp.display2DBox(cnt?, boxes[box].GetRow, boxes[box].GetCol, boxes[box].GetRow, boxes[box].GetCol + boxes[box].GetLength)

  repeat
    waitcnt((clkfreq / 1200) + cnt)
  '  pst.Clear
    pst.NewLine
    positionPadle

    _XPos := XPos / 16
    _YPos := YPos / 16
    pst.Str(String("Check: Col:"))
    pst.Dec(_XPos)
    pst.Str(String(" vs "))
    pst.Dec(padle.GetCol)
    pst.Str(String(" - Row:"))
    pst.Dec(_YPos)
    pst.Str(String(" vs "))
    pst.Dec(padle.GetRow)

    pst.NewLine
    pst.Str(String("XDir: "))
    pst.Dec(XDir)
    pst.Str(String(" YDir: "))
    pst.Dec(YDir)
    
    repeat box from 0 to 19
      if boxes[box].TopBottomCollision(_YPos, _XPos)        
        YDir *= -1
        tmp.display2DBox(0, boxes[box].GetRow, boxes[box].GetCol, boxes[box].GetRow, boxes[box].GetCol + boxes[box].GetLength)
        boxes[box].Disable 
      if boxes[box].SidesCollision(_YPos, _XPos)
        XDir *= -1
        tmp.display2DBox(0, boxes[box].GetRow, boxes[box].GetCol, boxes[box].GetRow, boxes[box].GetCol + boxes[box].GetLength)
        boxes[box].Disable                                          
      
    if padle.TopBottomCollision(_YPos, _XPos)
'      pst.Str(String("Collision with padle (Top-Bottom)"))
      YDir *= -1 
    if padle.SidesCollision(_YPos, _XPos)
'      pst.Str(String("Collision with padle (Sides)"))
      XDir *= -1
    drawPadle                                                       
      
    
    _XDir := XDir
    XDir ^= ((XPos =< 0) ^ (XPos => 624))
    

    _YDir := YDir
    YDir ^= ((YPos =< 0) ^ (YPos => 464))
    

    if XDir == 0
      XDir := 1
    if YDir == 0
      YDir := 1
    XDir #>= -1 <# 1
    YDir #>= -1 <# 1

    XPos += XDir
    YPos += YDir

    if _XDir <> XDir | _YDir <> YDir
      retronitus.playSoundFX(7, @BreakBlock)

  tmp.mouseCursorTile(0)
  tmp.printCursorRate(0)

PRI drawPadle
  if padle.GetCol > 0
    tmp.display2DBox(0, padle.GetRow, 0, padle.GetRow, padle.GetCol -1)
  if padle.GetCol + padle.GetLength + 1 < 40
    tmp.display2DBox(0, padle.GetRow, padle.GetCol + padle.GetLength + 1, padle.GetRow, 40)
  tmp.display2DBox(5000, padle.GetRow, padle.GetCol, padle.GetRow, padle.GetCol + padle.GetLength)

PRI positionPadle
  padle.setCol(((mouse.abs_x / 10) - (padle.getLength / 2)) #> 0 <# (40 - (padle.getLength + 1)))  

DAT

' //////////////////////Mouse Pointer//////////////////////////////////////////////////////////////////////////////////////////

ballPointer             long    %%0000002222000000
                        long    %%0000233333320000
                        long    %%0002333333332000
                        long    %%0023333333333200
                        long    %%0233333333333320
                        long    %%0233333333333320
                        long    %%2333333333333332
                        long    %%2333333333333332
                        long    %%2333333333333332
                        long    %%0233333333333320
                        long    %%0233333333333320
                        long    %%0023333333333200
                        long    %%0002333333332000
                        long    %%0002333333330000
                        long    %%0000233333320000
                        long    %%0000002222000000

BreakBlock file "BreakBlock.rsf"

nyan       long 0
           file "NyanCat.rmd"                        